package net.knarcraft.jarupdater.utility;

import org.junit.Test;

import java.io.File;
import java.nio.file.Paths;

import static junit.framework.TestCase.*;
import static net.knarcraft.jarupdater.utility.DownloaderUtil.*;

public class DownloaderUtilTest {

    @Test
    public void getFileNameFromURLValidTest() {
        assertEquals("minecraft-server-launcher-1.1-SNAPSHOT.jar",
                getFileNameFromURL("https://jenkins.knarcraft.net/job/KnarCraft/job/" +
                        "Minecraft-Server-Launcher/minecraft-server-launcher-1.1-SNAPSHOT.jar"));
    }

    @Test(expected = IllegalArgumentException.class)
    public void getFileNameFromURLInvalidTest() {
        getFileNameFromURL("https://knarcraft.net");
    }

    @Test
    public void stringEndsWithExtensionValidTest() {
        assertTrue(stringEndsWithExtension("MinecraftServerLauncher.jar"));
    }

    @Test
    public void stringEndsWithExtensionInvalidTest() {
        assertFalse(stringEndsWithExtension("MinecraftServerLauncherjar"));
        assertFalse(stringEndsWithExtension("MinecraftServerLauncherjar.htacces"));
        assertFalse(stringEndsWithExtension("MinecraftServerLauncher.jar.hahaha"));
    }

    @Test
    public void downloadFileTest() {
        assertTrue(downloadFile("https://jenkins.knarcraft.net/job/KnarCraft/job/Minecraft-Server-Launcher/job" +
                        "/master/10/artifact/target/minecraft-server-launcher-1.1-SNAPSHOT-jar-with-dependencies.jar",
                Paths.get(getApplicationWorkDirectory() + File.separator + "launcher.jar")));
    }

}
